=== debian/changelog ===
scm (5e5-4) unstable; urgency=medium

  * New maintainer (Closes: #721061).
  * Repackage with dh.
  * man-page chapter fix.
  * Lintian fixups, including relative path references.
  * Switch from texi2html to makeinfo for manual build.
  * Switch to arch 'any'.
  * Remove build flag ("-F inexact") so that test suite passes.
  * Added #define SHORT_INT for ppc64 in scmfig.h (Closes: #476807).

 -- Bryan Newbold <bnewbold@robocracy.org>  Mon, 31 Jul 2017 23:46:47 -0700

scm (5e5-3.3) unstable; urgency=low

  * Non-maintainer upload.
  * Fixed texinfo errors (Closes: #712339)
  * Removed install-info from maintainer scripts (Closes: #708498)

 -- Hilko Bengen <bengen@debian.org>  Sat, 23 Nov 2013 15:14:04 +0100

scm (5e5-3.2) unstable; urgency=low

  * NMU, added armhf in arch list. (Closes: #604537)

 -- Konstantinos Margaritis <markos@debian.org>  Thu, 24 Feb 2011 15:44:36 +0000

scm (5e5-3.1) unstable; urgency=low

  * Non-maintainer upload.
    ACKed by maintainer. 
  * Update debian/control.
    - Add support sh4, kfreebsd-amd64 and kfreebsd-i386.
      (Closes: #558213, #559017)
    - Replacing libreadline5-dev build dependency with libreadline-dev.
      (Closes: #553847)

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Mon, 01 Mar 2010 14:58:29 +0900

scm (5e5-3) unstable; urgency=low

  * build.scm (build-continue-ia64): New function, to encapsulate the method
  for building continue-ia64.o.
  (link-c-program/linux-ia64): Use build-continue-ia64.
  (make-archive/linux-ia64): New command, to use build-continue-ia64.
  (Closes: #483273).
  
 -- Thomas Bushnell, BSG <tb@debian.org>  Sat, 26 Jul 2008 12:08:17 -0700

scm (5e5-2) unstable; urgency=low

  * continue.h: actually make the change mentioned in 5e5-1.
  * Makefile: Likewise.
  * xgen.scm: Likewise.
  * scm.1: Likewise.
  * build.scm: Likewise.

 -- Thomas Bushnell, BSG <tb@debian.org>  Mon, 18 Feb 2008 15:37:29 -0500

scm (5e5-1) unstable; urgency=low

  * New upstream release.
  * continue.h: Repeat change from 5e1-2.
  * xgen.scm: Repeat change from 5e2-4.
  * scm.1: Repeat change from 5e2-4.
  * build.scm: Repeat change from 5e3-5.
  * Makefile: Repeat change from 5e3-2.
  * debian/control (Build-Depends): Require at least version 3b1 of slib.
  (scm Depends): Likewise.
  (libscm-dev Depends): Likewise.
    
  * Makefile (scm.info): Add explicit dependency on features.txi and
    platform.txi.  For some reason the one through $(texifiles) is 
    failing mysteriously.  Perhaps this is a make bug.
  
 -- Thomas Bushnell, BSG <tb@debian.org>  Mon, 04 Feb 2008 20:53:13 -0500

scm (5e4-5) unstable; urgency=low

  * debian/control (libscm-dev/Description): Drop mistaken extra spaces
    in description.
  
  * debian/control (libscm-dev/Depends): Use $(binary:Version} for the
    dependency rather than ${source:Version}.
  
  * debian/control (Standards-Version): Update to 3.7.3.  (No changes needed.)

 -- Thomas Bushnell, BSG <tb@debian.org>  Wed, 16 Jan 2008 16:08:07 -0500

scm (5e4-4) unstable; urgency=low

  * continue.h: Fix spelling of STACK_GROWS_UP in change from 5e4-1.
  
  * Makefile: Repeat change from 5e3-2.

 -- Thomas Bushnell, BSG <tb@debian.org>  Sun, 13 Jan 2008 22:15:05 -0500

scm (5e4-3) unstable; urgency=low

  * debian/rules (SCM_OPTIONS): Add -F differ. 
  
  * debian/control (libscm-dev): New package.  We don't make a shared library
    because there is no standardization of SCM options, and no way to indicate
    in a non-brittle fashion what SCM options are available in any particular
    build, nor any standardization of sonames.
  * debian/rules (build): Build libscm.a too.
    (install): Install libscm.a, scm.h, scmfig.h, and scmflags.h into
    libscm-dev. Don't install header files in scm package.
    (Closes: #459828)
  
  * debian/copyright: Add proper authorship and copyright information; make
    mention of the special library linking exception since we are now
    packaging the library.
  
 -- Thomas Bushnell, BSG <tb@debian.org>  Wed, 09 Jan 2008 14:08:12 -0500

scm (5e4-2) unstable; urgency=low

  * Properly acknowledge NMU 5e3-6.1.  (Closes: #369576, #458284).

 -- Thomas Bushnell, BSG <tb@debian.org>  Sun, 30 Dec 2007 17:10:06 -0800

scm (5e4-1) unstable; urgency=low

  * New upstream release.
  * debian/control: Require at least version 3a5 of slib.
  
  * debian/postrm: New file to remove /usr/lib/scm/implcat and
    /usr/lib/scm/slibcat upon purge.  (Closes: #455124).  Thanks to Kumar
    Appaiah for the fix.
  
  * debian/control (Architecture): Add armel and armeb. (Closes: #408792).
  
  * debian/rules (install): Don't use -s when installing.  dh_strip should
    be sufficient, and this should make the nostrip build option work.
    (Closes: #438004).

  * continue.h: Repeat change from 5e1-2.
  
  * xgen.scm: Repeat change from 5e2-4.
  
  * scm.1: Repeat change from 5e2-4.
  
  * build.scm: Repeat change from 5e3-5.
  
 -- Thomas Bushnell, BSG <tb@debian.org>  Fri, 28 Dec 2007 15:56:00 -0800

scm (5e3-6.1) unstable; urgency=low

  * Non-maintainer upload. 
  * Split doc-base file into two files, add missing 'Index' fields for 'info'
    sections (closes: #369576).
    Thanks to Robert Luberda for the patch.
  * Remove from rules/postinst/postrm any manually doc-base handling code,
    since dh_installdocs supports doc-base on its own.
    Thanks to Robert Luberda for the patch.

 -- Neil Williams <codehelp@debian.org>  Sun, 15 Jul 2007 21:14:17 +0100

scm (5e3-6) unstable; urgency=medium
  
  * Medium urgency because this is a release critical issue, 
    and is part of the fix made in slib 3a4-4.

  * debian/control (scm): Add version specification to the slib
    dependency (>> 3a4).

 -- Thomas Bushnell, BSG <tb@debian.org>  Wed,  8 Nov 2006 00:12:38 -0800

scm (5e3-5) unstable; urgency=low

  * build.scm (build: C-libraries): Duplicate linux section for linux-ia64.

 -- Thomas Bushnell, BSG <tb@debian.org>  Sat, 28 Oct 2006 02:27:38 -0700

scm (5e3-4) unstable; urgency=low


