=== debian/control ===
Source: scm
Section: interpreters
Priority: optional
Maintainer: Bryan Newbold <bnewbold@robocracy.org>
Build-Depends: slib (>> 3b1), libncurses5-dev, libreadline-dev, texinfo, libx11-dev, debhelper (>= 9)
Standards-Version: 3.9.8
Homepage: http://people.csail.mit.edu/jaffer/SCM.html

Package: scm
Architecture: any
Depends: slib (>> 3b1), ${shlibs:Depends}, ${misc:Depends}
Description: Scheme language interpreter
 SCM conforms to the R5RS (Revised^5 Report on the Algorithmic Language Scheme)
 and IEEE P1178 specifications, and is portable across many architectures and
 operating systems. It additionally includes a set of popular Common Lisp
 functions, POSIX and X Windows integration, and the Hobbit scheme-to-C
 compiler.

Package: libscm-dev
Architecture: any
Section: libdevel
Depends: scm (= ${binary:Version}), slib (>> 3b1), ${misc:Depends}
Description: Embeddable library for SCM Scheme language interpreter
 This is a static library which provides the functionality of SCM, making it
 convenient add scheme functionality to other programs.
