=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_testdir:
	dh_testdir
	test -e /usr/share/slib || \
		(echo "Must have slib installed for compile" && exit 1)

override_dh_auto_configure:
	dh_auto_configure
	cp debian/require.scm.debian require.scm
	cp debian/scm.opt.debian libscm.opt

override_dh_auto_build:
	make scmlit
	# Use the same options for both static library and executable
	./build -p linux -hsystem -f libscm.opt
	./build -p linux -hsystem -f libscm.opt -t lib
	makeinfo --html --no-split scm.texi
	makeinfo --html --no-split Xlibscm.texi
	cp XlibScm.html Xlibscm.html
	cp ChangeLog changelog

override_dh_auto_test:
	# skip: inexact tests fail; fixed in later upstream version

override_dh_strip:
	dh_strip --no-automatic-dbgsym

override_dh_auto_install:
	# skip; files listed explicitly
