## scm 5f2

=== debian/changelog ===
scm (5f2-2build2) disco; urgency=medium

  * No-change rebuild for readline soname change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 14 Jan 2019 20:04:03 +0000

scm (5f2-2build1) cosmic; urgency=medium

  * No-change rebuild for ncurses soname changes.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 03 May 2018 14:19:02 +0000

scm (5f2-2) unstable; urgency=medium

  * Cherry-pick Jakub Bogusz's upstream patch to fix a 32-bit platform bignum
    bug causing test failures and FTBFS (Closes: #874112)

 -- Bryan Newbold <bnewbold@robocracy.org>  Thu, 12 Oct 2017 21:01:09 -0700

scm (5f2-1) unstable; urgency=medium

  * New upstream release (Closes: #791958) with improved floating point
    performance and many fixes over the years.
  * Automated tests now run correctly (inexact fixed upstream).
  * Fix build on ARM64 (Closes: #791959). Thanks to Martin Michlmayr!
  * Copyright file clarifications, including new upstream mix of GPL-3+ and
    LGPL-3+; fixing author typo; documentation under GFDL; some files removed
    upstream.
  * Update Debian Standards-Version to 4.0.0.
  * Fix build in hurd-i386 (Closes: #768486). Thanks to Svante Signell!

 -- Bryan Newbold <bnewbold@robocracy.org>  Tue, 01 Aug 2017 21:48:28 -0700
