=== debian/control ===
Source: scm
Section: interpreters
Priority: optional
Maintainer: Bryan Newbold <bnewbold@robocracy.org>
Build-Depends: slib (>> 3b1), libncurses5-dev, libreadline-dev, texinfo, libx11-dev, debhelper (>= 9)
Standards-Version: 4.0.0
Homepage: http://people.csail.mit.edu/jaffer/SCM.html
Vcs-Git: https://git.bnewbold.net/debian/scm

Package: scm
Architecture: any
Depends: slib (>> 3b1), ${shlibs:Depends}, ${misc:Depends}
Suggests: r5rs-doc
Description: Scheme language interpreter
 SCM conforms to the R5RS (Revised^5 Report on the Algorithmic Language Scheme)
 and IEEE P1178 specifications, and is portable across many architectures and
 operating systems. It additionally includes a set of popular Common Lisp
 functions, POSIX and X Windows integration, and the Hobbit scheme-to-C
 compiler.

Package: libscm-dev
Architecture: any
Section: libdevel
Depends: scm (= ${binary:Version}), slib (>> 3b1), ${misc:Depends}
Suggests: r5rs-doc
Description: Embeddable library for SCM Scheme language interpreter
 Compact static library containing the SCM interpreter and an API making it
 easy to integrate into other programs as a scripting language.
