=== debian/rules ===
--- 
+++ 
@@ -22,7 +22,7 @@
 		(echo "Must have slib installed for compile" && exit 1)
 
 override_dh_auto_configure:
-	dh_auto_configure
+	./configure
 	cp debian/require.scm.debian require.scm
 	cp debian/scm.opt.debian libscm.opt
 
@@ -36,11 +36,12 @@
 	cp XlibScm.html Xlibscm.html
 	cp ChangeLog changelog
 
-override_dh_auto_test:
-	# skip: inexact tests fail; fixed in later upstream version
-
 override_dh_strip:
 	dh_strip --no-automatic-dbgsym
 
 override_dh_auto_install:
+	# Make .scm scheme library scripts non-executable...
+	chmod a-x *.scm *.c
+	# except compile.scm
+	chmod a+x compile.scm
 	# skip; files listed explicitly
