## scm 5f3

=== debian/changelog ===
scm (5f3-1) unstable; urgency=medium

  * Update debian/watch uscan support file
  * New upstream version
    - removed upstream: rwb-isam.scm wbtab.scm
  * Trim trailing whitespace.
  * Use secure URI in Homepage field.
  * Bump debhelper from deprecated 9 to 13
  * Remove listed license files (COPYING fdl.texi) from copyright.
  * Avoid explicitly specifying -Wl,--as-needed linker flag.
  * Forward port patches; bigrecy_32bit_upstream has been upstreamed
  * Rules-Requires-Root: no
  * Remove ancient /usr/doc/scm/ business from prerm
  * Quote "Thomas Bushnell, BSG" in debian/changelog to placate lintian
  * Make debian/* stanza in debian/copyright less finicky
  * Include quilt patches for readline bug, and more! (closes: #831017)
  * Team Maintain

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 02 Dec 2021 16:31:25 +0000
