=== debian/control ===
--- 
+++ 
@@ -1,11 +1,19 @@
 Source: scm
 Section: interpreters
 Priority: optional
-Maintainer: Bryan Newbold <bnewbold@robocracy.org>
-Build-Depends: slib (>> 3b1), libncurses5-dev, libreadline-dev, texinfo, libx11-dev, debhelper (>= 9)
-Standards-Version: 4.0.0
-Homepage: http://people.csail.mit.edu/jaffer/SCM.html
-Vcs-Git: https://git.bnewbold.net/debian/scm
+Maintainer: Debian Scheme Dream Team <debian-scheme@lists.debian.org>
+Uploaders: Bryan Newbold <bnewbold@robocracy.org>,
+	   Barak A. Pearlmutter <bap@debian.org>
+Build-Depends: debhelper-compat (= 13),
+		slib (>> 3b1),
+		libncurses5-dev, libreadline-dev,
+		texinfo,
+		libx11-dev,
+Standards-Version: 4.6.0
+Rules-Requires-Root: no
+Homepage: https://people.csail.mit.edu/jaffer/SCM.html
+Vcs-Git: https://salsa.debian.org/scheme-team/scm.git
+Vcs-Browser: https://salsa.debian.org/scheme-team/scm
 
 Package: scm
 Architecture: any
