=== debian/changelog ===
scm (5f4-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Build with -std=gnu17 to workaround FTBFS with GCC 15.
    (Closes: #1097858)

 -- Adrian Bunk <bunk@debian.org>  Sat, 25 Oct 2025 18:54:34 +0300

scm (5f4-3) unstable; urgency=medium

  * define-scm-llong-for-64-bit-archs.patch: Fix builds on riscv64 as well

 -- Gwen Weinholt <weinholt@debian.org>  Mon, 13 Jan 2025 00:16:35 +0100

scm (5f4-2) unstable; urgency=medium

  * define-scm-llong-for-64-bit-archs.patch: Fix building on most 64-bit
    archs (hopefully).

 -- Gwen Weinholt <weinholt@debian.org>  Sun, 12 Jan 2025 23:04:32 +0100

scm (5f4-1) unstable; urgency=medium

  [ Gwen Weinholt ]
  * New upstream version 5f4
  * do-not-use-catalog-expand-path.patch: Support for slib 3b6.
  * debian/patches: Rebase patches.
  * debian/patches/fix-numerous-compilation-errors.patch: Fix various
    compiler warnings (Closes: #1081101)
  * debian/patches/fix-i386-build.patch: Fix i386 compilation.
    Thanks to Jens Thiele for the patch
  * debian/patches/fix-arm-builds.patch: Fix armel, armhf builds

  [ xiaojuan zhai ]
  * Add support for loong64 (Closes: #1050764)

 -- Gwen Weinholt <weinholt@debian.org>  Sat, 11 Jan 2025 22:07:34 +0100

scm (5f3-6) unstable; urgency=medium

  * Fix fix-implicit-decl-libc.patch for mips64el builds

 -- Gwen Weinholt <weinholt@debian.org>  Sat, 04 May 2024 16:12:22 +0200

scm (5f3-5) unstable; urgency=medium

  * Fix build with opaque ncurses.
    Thanks to Sven Joachim for the patch (Closes: #1057602)
  * Fix implicit declarations of some libc functions
  * Fix implicit declarations of some init_*() functions
  * debian: Fix my name

 -- Gwen Weinholt <weinholt@debian.org>  Sat, 20 Apr 2024 12:25:18 +0200

scm (5f3-4) unstable; urgency=medium

  * Team upload.
  * Fix ftbfs on mipsel. Closes: #1029122
  * Use libncurses-dev instead of libncurses5-dev

 -- Bo YU <tsu.yubo@gmail.com>  Wed, 18 Jan 2023 12:34:18 +0800

scm (5f3-3) unstable; urgency=medium

  * Team upload.

  * Fix ftbfs on riscv64, s390x, mips64el. Closes: #1026844, #387087

 -- Bo YU <tsu.yubo@gmail.com>  Sun, 15 Jan 2023 09:58:02 +0800

scm (5f3-2) unstable; urgency=medium

  Team upload.

  [ Göran Weinholt ]
  * use-compiler-flags.patch: Pass through compilation flags to gcc
  * debian/patches/disable-bigrecy.patch: Disable bigrecy() again
    (Closes: #1024882)
  * debian/rules: Disable C optimizations to work around a test failure
  * debian/control: Add myself to uploaders

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster
  * Update standards version to 4.6.1, no changes needed.

 -- Göran Weinholt <weinholt@debian.org>  Sun, 18 Dec 2022 14:15:57 +0100
