=== debian/control ===
--- 
+++ 
@@ -3,13 +3,14 @@
 Priority: optional
 Maintainer: Debian Scheme Dream Team <debian-scheme@lists.debian.org>
 Uploaders: Bryan Newbold <bnewbold@robocracy.org>,
-	   Barak A. Pearlmutter <bap@debian.org>
+	   Barak A. Pearlmutter <bap@debian.org>,
+	   Gwen Weinholt <weinholt@debian.org>
 Build-Depends: debhelper-compat (= 13),
-		slib (>> 3b1),
-		libncurses5-dev, libreadline-dev,
+		slib,
+		libncurses-dev, libreadline-dev,
 		texinfo,
 		libx11-dev,
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Homepage: https://people.csail.mit.edu/jaffer/SCM.html
 Vcs-Git: https://salsa.debian.org/scheme-team/scm.git
@@ -17,7 +18,7 @@
 
 Package: scm
 Architecture: any
-Depends: slib (>> 3b1), ${shlibs:Depends}, ${misc:Depends}
+Depends: slib, ${shlibs:Depends}, ${misc:Depends}
 Suggests: r5rs-doc
 Description: Scheme language interpreter
  SCM conforms to the R5RS (Revised^5 Report on the Algorithmic Language Scheme)
@@ -29,7 +30,7 @@
 Package: libscm-dev
 Architecture: any
 Section: libdevel
-Depends: scm (= ${binary:Version}), slib (>> 3b1), ${misc:Depends}
+Depends: scm (= ${binary:Version}), slib, ${misc:Depends}
 Suggests: r5rs-doc
 Description: Embeddable library for SCM Scheme language interpreter
  Compact static library containing the SCM interpreter and an API making it
