=== debian/rules ===
--- 
+++ 
@@ -11,6 +11,9 @@
 # package maintainers to append CFLAGS
 #export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
 # package maintainers to append LDFLAGS
+
+# Upstream builds without optimization and tests fail with even -O1.
+CFLAGS += -O0 -std=gnu17
 
 %:
 	dh $@
