=== debian/watch ===
# watch control file for uscan
# See uscan(1) for format

version=4

https://ftp.gnu.org/gnu/@PACKAGE@/@PACKAGE@-@ANY_VERSION@@ARCHIVE_EXT@
